routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\AgentController;
use App\Http\Controllers\AnnouncementController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
// display list of announcement 
Route::get('/', [App\Http\Controllers\AnnouncementController::class, 'list'])->name('home');

//add the resource route of Agent
Route::resource("agents", AgentController::class);

//add the ressource route of announcement
Route::resource("announcements", AnnouncementController::class);

app/Models/Announcement.php
<?php

namespace App\Models;

use App\Models\Agent;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class announcement extends Model
{
    use HasFactory;
    protected $fillable = ['reference', 'picture','price','area','roomsNumber','agent_id'];

    //Get the Agent that owns the announcement
    public function Agent()
    {
        return $this->belongsTo(Agent::class);
    }
    
}

app/Http/Controllers/AnnouncementController.php
<?php

namespace App\Http\Controllers;

use App\Models\Agent;
use App\Models\Announcement;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\File; 
use Illuminate\Support\Facades\Storage;

class AnnouncementController extends Controller
{
    /**
     * Display a listing of the resource for the admin.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //get all announcements 
        //select * from agents inner join announcements on agents.id = announcements.agent_id
        $announcements = Announcement::latest()->get();
        $agents = Agent::get();
        //Display announcements by agent 
        if(\request('agent'))
        {
        // select * from agents inner join announcements on agents.id = announcements.agent_id where announcements.agent_id =?
            $announcements = Announcement::where('agent_id',request('agent'))->get();
        }
        //Display announcements by price
        if(\request('start_price') )
        {
            $announcements = Announcement::whereBetween('price',[request('start_price'),request('end_price')])->get();
            // $announcements = Announcement::where('agent_id',request('agent'))->get();
        }
        //transmit announcements to the view
        return view("announcement.index", compact("announcements","agents"));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $agent_id = null;
        $agents = Agent::orderBy('id')->get();
        return view("announcement.edit",compact("agents","agent_id"));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
         //  1.validation of the form */
        $request->validate([
            "reference" => 'required',
            "picture" => 'required|mimes:jpg,png,jpeg|max:5048',
            "price" => 'required',
            "area" => 'required',
            "roomsNumber" => 'required',
            //don't forget to add require for agent_id
            "agent_id" => 'required'
        ]);

        //  2.get new name of picture that contain the reference of announcement
            $newPictureName = time() . '_' . $request->reference . '.' .
            $request->picture->extension();

        // 3.upload the picture in public/img 
            $request->picture->move(public_path('img'),$newPictureName);

        // 4.add announcement in database
        Announcement::create([
            "reference" => $request->reference,
            "picture" => $newPictureName,
            "price" => round($request->price,2),
            "area" => $request->area,
            "roomsNumber" => $request->roomsNumber,
            "agent_id" => $request->agent_id
        ]);
        
        // 4.redirect to index page and get message success
        return redirect(route('announcements.index'))->with('success','Votre annonce a bien été ajoutée');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Announcement  $announcement
     * @return \Illuminate\Http\Response
     */
    public function show(Announcement $announcement)
    {
        //Get the announcement selected 
        return view("announcement.show", compact("announcement"));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Announcement  $announcement
     * @return \Illuminate\Http\Response
     */
    public function edit(Announcement $announcement)
    {
        $agents = Agent::orderBy('id')->get();
        $agent_id=$announcement->agent_id;
        return view("announcement.edit", compact("announcement","agents","agent_id"));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Announcement  $announcement
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Announcement $announcement)
    {
         // 1.validation 
        $rules = [
            "reference" => 'required',
            "price" => 'required',
            "area" => 'required',
            "roomsNumber" => 'required',
            "agent_id" => 'required'
        ];
        // if a new picture is send it
        if ($request->has("picture")) {
        // we add validation for the picture"
        $rules["picture"] = 'required|mimes:jpg,png,jpeg|max:5048';
        }
        $this->validate($request, $rules);
        // 2. we upload the picture in "public/img"
        if ($request->has("picture")) {
        //we delete the old picture
            File::delete("img/$announcement->picture");
        //we create a new name of the new picture
            $newPictureName = time() . '_' . $request->reference . '.' .
            $request->picture->extension();
        // we upload the new picture in "public/img"
            $request->picture->move(public_path('img'),$newPictureName);
        }

        // 2.update the announcement information
        $announcement->update([
            "reference" => $request->reference,
            "picture" => isset($newPictureName) ? $newPictureName : $announcement->picture,
            "price" => $request->price,
            "area" => $request->area,
            "roomsNumber" => $request->roomsNumber,
            "agent_id" => $request->agent_id
        ]);
        // 3.redirect to index page
        return redirect(route("announcements.index"));
    }
    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Announcement  $announcement
     * @return \Illuminate\Http\Response
     */
    public function destroy(Announcement $announcement)
    {
        //delete the picture
        File::delete("img/$announcement->picture");
        //delete the announcement
        $announcement->delete();
        // Redirection to index page"
        return redirect(route('announcements.index'));
    }
    /**
    * Display a listing of the resource for the public.
    *
    * @return \Illuminate\Http\Response
    */
    public function list()
    {
        //get all announcements
        $announcements = Announcement::latest()->get();
        //transmit agents to the view
        return view("home", compact("announcements"));
    }
}

resources/views/announcement/edit.blade.php
@extends('base')
@section("title","edit")

@section('content')
    <!-- if we have announcement -->
	@if (isset($announcement))
    <!-- the form is managed by the route "announcements.update" -->
        <form  method="POST" action="{{ route('announcements.update', $announcement) }}" 
            enctype="multipart/form-data">
            <input type="hidden" name="_method" value="PUT"
        >
    @else 
    <!-- the form is managed by the route "announcements.store" -->  
        <form method="POST" action="{{ route('announcements.store') }}" 
            enctype="multipart/form-data" 
        >
    @endif
    @csrf

    <!-- if we have  $announcement->picture, display it -->
    @if(isset($announcement->picture))
        <p>
            <img class="mx-auto d-block" src="{{ asset('img/'.$announcement->picture) }}" 
            alt="announcements picture" style="max-height: 400px;"
        >
        </p>
    @endif
        <p>
            <label for="picture" >Photo de l'annonce</label><br/>
            <input class="form-control" type="file" name="picture" id="picture"> 
        <!-- error message "picture" -->
            @error("picture")
                <div>{{ $message }}</div>
            @enderror
        </p>
    
        <p>
            <label for="reference" >Référence</label>
        <!-- if we have $announcement->reference, we complete the input value -->
            <input class="form-control" type="text" name="reference" 
                value="{{ isset($announcement->reference) ? $announcement->reference : old('reference') }}" 
                id="reference" placeholder="Référence"
            >
        <!-- error message -->
            @error("reference")
                <div>{{ $message }}</div>
            @enderror
        </p>

        <p>
            <label for="price">Prix</label>
        <!-- if we have $announcement->price, we complete the input value -->
            <input class="form-control" type="number" id="price" name="price" step="0.01" 
                value="{{ isset($announcement->price) ? $announcement->price : old('price') }}" 
                id="price" placeholder="Prix"
            >
        <!-- error message -->
            @error("reference")
                <div>{{ $message }}</div>
            @enderror
        </p>

        <p>
            <label for="area">Surface Habitable</label>
        <!-- if we have $announcement->area, we complete the input value -->
            <input class="form-control" type="number" id="area" name="area" step="0.01" 
                value="{{ isset($announcement->area) ? $announcement->area : old('area') }}" 
                id="area" placeholder="Surface Habitable"
            >
        <!-- error message -->
            @error("area")
                <div>{{ $message }}</div>
            @enderror
        </p>

        <p>
            <label for="roomsNumber">Nombre de pièces</label>
        <!-- if we have $announcement->nu, we complete the input value -->
            <input class="form-control" type="number" id="roomsNumber" name="roomsNumber"  
                value="{{ isset($announcement->roomsNumber) ? $announcement->roomsNumber : old('roomsNumber') }}" 
                id="roomsNumber" placeholder="Nombre de pièces"
            >
        <!-- error message -->
            @error("roomsNumber")
                <div>{{ $message }}</div>
            @enderror
        </p>
        <p>
            <label for="area"> Agent </label>
            <select class="form-control agents" id="agent_id" name="agent_id">
                <option value="" selected=" ">Veuillez choisir...</option>  
                @foreach($agents as $agent)
                    <option 
                    value="{{ isset($agent->id) ? $agent->id : old('id') }}"
                    @if($agent->id == $agent_id)
                    selected
                    @endif
                    >
                    {{ $agent->lastName.' '.$agent->firstName }}
                    </option>
                @endforeach
            </select>
            @error("agent_id")
                <div>{{ $message }}</div>
            @enderror
        </p>   
            <button type="submit" class="btn btn-success"><i class="fas fa-check"></i> Valider </button>
        </form>
@endsection

@section("scripts")
    <script src="{{asset('js/select2agent.js')}}"></script>
@endsection

resources/views/announcement/index.blade.php
@extends('base')
@section("title","index")
@section('content')


{{-- {{dump($announcements)}}  --}}
	
    <div class= "row">
        <div class="col-3">
        <!-- The form of the filter by agent and price -->
            <form method="GET" action="{{ route('announcements.index') }}" enctype="multipart/form-data" >
                <h3>Liste des Agents</h3>
                <select class="form-control agents" id="agent" name="agent">
                    <option value="" selected=" ">Veuillez choisir...</option> 
                    @foreach ($agents as $agent)
                    {{-- <p><a href="/announcements?agent={{$agent->id}}">{{$agent->firstName}}</a></p> --}}
                    <option value="{{ $agent->id }}">{{ $agent->lastName.' '.$agent->firstName }}</option>
                    @endforeach  
                </select>
                <hr>
                <p>
                <h3>Price</h3>
                <div class="row ">
                    <input class="col inputMin" type="number" name="start_price" id="min" placeholder="Prix min"> 
                        <br>
                    <input class="col" type="number" name="end_price" id="max" placeholder="Prix max"> 
                </div>
                        <br>
                <div id="slider" style="margin-bottom: 3rem;"></div>
                <button type="submit" class="btn btn-success filter"> Filtrer </button>	
            </form>
        </div>
        <!-- The table to display the announcements list -->
        <div class="col-9 table-responsive">
            <table class="table">
                <thead class="thead-dark">
                    <tr>
                        <th>Agent </th>
                        <th>Reference</th>
                        <th>image </th>
                        <th>Prix </th>
                        <th>Surface habitable </th>
                        <th>Nombre de pièces </th>
                        <th>Voir </th>
                        <th>Editer</th>
                        <th>Supprimer</th>
                    </tr>
                </thead>
                <tbody>
			<!-- We browse the collection of announcement   -->
                    @foreach ($announcements as $announcement)
                    <tr>
                        <td>{{$announcement->agent->lastName.' '.$announcement->agent->firstName}}</td>
                        <td>{{$announcement->reference}}</td>
                        <td><img src="{{asset('img/'.$announcement->picture)}}"  
                            alt="picture of the announcement" height=50 width=50>
                        </td>
                        <td>{{$announcement->price}}€</td>
                        <td>{{$announcement->area}} m²</td>
                        <td>{{$announcement->roomsNumber}}</td>
                        <td>
            <!-- Link to show announcement  -->
                            <a href="{{ route('announcements.show', $announcement) }}" 
                                title="view the announcement" >
                                    <i class="fas fa-eye fa-2x"></i>
                            </a>
                        </td>
                        <td>
			<!-- Link to edit announcement  -->
                            <a href="{{ route('announcements.edit', $announcement ) }}" 
                                title="edit the announcement" >
                                <i class="fas fa-edit fa-2x"></i>
                            </a>
                        </td>
                        <td>
			<!-- The form to delete announcement -->
                            <form method="POST" action="{{ route('announcements.destroy', $announcement ) }}" 
                                onsubmit="return confirm('Êtes-vous sûr de vouloir supprimer ?');">
                                <input type="hidden" name="_method" value="DELETE">
                                @csrf
                                <button class="btn btn-outline-danger">
                                    <i class="fas fa-trash-alt fa-2x"></i>
                                </button>
                            </form>																								
                        </td>
                    </tr>
                    @endforeach
                </tbody>
            </table>
            <a href="{{ route('announcements.create') }}">
                <button class="btn btn-success">
                    <i class="fas fa-plus"></i>
                        Ajouter une announce
                </button>
            </a>	   
        </div>
    <div>
@endsection
@section("scripts")
<script>
    var slider = document.getElementById('slider');
    if (slider) {
    const min = document.getElementById('min')
    const max = document.getElementById('max')
    const range = noUiSlider.create(slider, {
        start: [min.value || 100, max.value || 100000],
        connect: true,
        step:100,
        range: {
            'min': 100,
            'max': 100000
        }
    });
    range.on('slide', function (values, handle) {
        console.log(values, handle)
        if (handle === 0) {
            min.value = Math.round(values[0])
        }
        if (handle === 1) {
            max.value = Math.round(values[1])
        }
    })
}
</script>
@endsection

resources/views/announcement/show.blade.php
@extends('base')
@section("title","view")
@section('content')
    <img img src="{{asset('img/'.$announcement->picture)}}"  
        alt="picture of the announcement" class="d-block w-100 " style="height:38rem;" src="#">
    <br>
    <div class="row">
        <div class="col col-sm-8">
            <div class="underline">
                <p> <strong>détaille de l'annonce</strong> </p> 
            </div>
            <br>
            <div class="description">
                <p>Prix:{{$announcement->price}} €</p>
                <p>Surface Habitable :{{$announcement->area}} m² environ</p>
                <p>Nombre de pièces:{{$announcement->roomsNumber}} Pièces
                    / {{$announcement->roomsNumber-1}} Chambre(s)
                </p>
                <p>Référence :{{$announcement->reference}}</p>
            </div>
            <br>
        </div>
        <div class="col col-sm-4">
            <div class="underline ">
                <p> <strong>Votre Agent</strong></p> 
            </div>
            <div class="description">
                <p>{{$announcement->agent->lastName.' '.$announcement->agent->firstName}}</p>   
            </div>
        </div>
    </div>
@endsection